REM: A batch program to rebuild the .. samples using Code::Blocks.
REM: The contents of the log file is erased 


REM: Set the paths
@set PATH=c:\Program Files\CodeBlocks;%PATH%
@set PATH=c:\Program Files (x86)\CodeBlocks;%PATH%

REM: Remove old files before we start
call CleanSamples
call CleanTutorials

REM: Change the directory to the parent (Pushes the directory change on to the stack)
pushd ..\Samples
if exist "..\output\Borland" rmdir /s /q "Win32++\output\Borland"
if exist "..\output\VS2003" rmdir /s /q "Win32++\output\VS2003"
if exist "..\output\MinGW" rmdir /s /q "Win32++\output\MinGW"


REM: Compile the code

codeblocks.exe --rebuild Browser\ProjectFiles\Browser.cbp                   >"..\output\CodeBlocks.log"
codeblocks.exe --rebuild CustomControl\ProjectFiles\CustomControl.cbp       >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Dialog\ProjectFiles\Dialog.cbp                     >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild DialogBars\ProjectFiles\DialogBars.cbp             >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild DialogDemo\ProjectFiles\DialogDemo.cbp             >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild DialogTab\ProjectFiles\DialogTab.cbp               >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Dock\ProjectFiles\Dock.cbp                         >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild DockContainer\ProjectFiles\DockContainer.cbp       >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild DockTabbedMDI\ProjectFiles\DockTabbedMDI.cbp       >>"..\output\CodeBlocks.log"
REM codeblocks.exe --rebuild DX\ProjectFiles\DX.cbp                         >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Explorer\ProjectFiles\Explorer.cbp                 >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild FastGDI\ProjectFiles\FastGDI.cbp                   >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild FormDemo\ProjectFiles\FormDemo.cbp                 >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Frame\ProjectFiles\Frame.cbp                       >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild MDIFrame\ProjectFiles\MDIFrame.cbp                 >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild MDIFrameDemo\ProjectFiles\MDIDemo.cbp              >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild MDIFrameSplitter\ProjectFiles\MDIFrameSplitter.cbp >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Networking\ClientDlg\Client.cbp                    >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Networking\ServerDlg\Server.cbp                    >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild NotePad\ProjectFiles\Notepad.cbp                   >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Performance\ProjectFiles\Performance.cbp           >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Picture\ProjectFiles\Picture.cbp                   >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild PropertySheet\ProjectFiles\PropertySheet.cbp       >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Scribble\ProjectFiles\Scribble.cbp                 >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Simple\ProjectFiles\Simple.cbp                     >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Splitter\ProjectFiles\Splitter.cbp                 >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild TabDemo\ProjectFiles\TabDemo.cbp                   >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Themes\ProjectFiles\Themes.cbp                     >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Threads\ProjectFiles\Threads.cbp                   >>"..\output\CodeBlocks.log"
codeblocks.exe --rebuild Tray\ProjectFiles\Tray.cbp                         >>"..\output\CodeBlocks.log"

REM: Copy the executables to the testing directories
mkdir "..\output\VS2003"
mkdir "..\output\VS2003\Debug"

ECHO "Copying VS2003 Debug files" >>"..\output\CodeBlocks.log"
copy Browser\ProjectFiles\Microsoft\Debug\Browser.exe                   "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy CustomControl\ProjectFiles\Microsoft\Debug\CustomControl.exe       "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Dialog\ProjectFiles\Microsoft\Debug\Dialog.exe                     "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy DialogBars\ProjectFiles\Microsoft\Debug\DialogBars.exe             "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy DialogDemo\ProjectFiles\Microsoft\Debug\DialogDemo.exe             "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy DialogTab\ProjectFiles\Microsoft\Debug\DialogTab.exe               "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Dock\ProjectFiles\Microsoft\Debug\Dock.exe                         "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy DockContainer\ProjectFiles\Microsoft\Debug\DockContainer.exe       "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy DockTabbedMDI\ProjectFiles\Microsoft\Debug\DockTabbedMDI.exe       "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy FormDemo\ProjectFiles\Microsoft\Debug\FormDemo.exe                 "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
REM copy DX\ProjectFiles\Microsoft\Debug\DX.exe                         "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Explorer\ProjectFiles\Microsoft\Debug\Explorer.exe                 "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy FastGDI\ProjectFiles\Microsoft\Debug\FastGDI.exe                   "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Frame\ProjectFiles\Microsoft\Debug\Frame.exe                       "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy MDIFrame\ProjectFiles\Microsoft\Debug\MDIFrame.exe                 "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy MDIFrameDemo\ProjectFiles\Microsoft\Debug\MDIDemo.exe              "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy MDIFrameSplitter\ProjectFiles\Microsoft\Debug\MDIFrameSplitter.exe "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Networking\ClientDlg\Microsoft\Debug\Client.exe                    "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Networking\ServerDlg\Microsoft\Debug\Server.exe                    "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy NotePad\ProjectFiles\Microsoft\Debug\Notepad.exe                   "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Performance\ProjectFiles\Microsoft\Debug\Performance.exe           "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Picture\ProjectFiles\Microsoft\Debug\Picture.exe                   "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy PropertySheet\ProjectFiles\Microsoft\Debug\PropertySheet.exe       "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Scribble\ProjectFiles\Microsoft\Debug\Scribble.exe                 "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Simple\ProjectFiles\Microsoft\Debug\Simple.exe                     "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Splitter\ProjectFiles\Microsoft\Debug\Splitter.exe                 "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy TabDemo\ProjectFiles\Microsoft\Debug\TabDemo.exe                   "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Themes\ProjectFiles\Microsoft\Debug\Themes.exe                     "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Threads\ProjectFiles\Microsoft\Debug\Threads.exe                   "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"
copy Tray\ProjectFiles\Microsoft\Debug\Tray.exe                         "..\output\VS2003\Debug"    >>"..\output\CodeBlocks.log"

mkdir "..\output\VS2003\Release"

ECHO "Copying VS2003 Release files" >>"..\output\CodeBlocks.log"
copy Browser\ProjectFiles\Microsoft\Release\Browser.exe                   "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy CustomControl\ProjectFiles\Microsoft\Release\CustomControl.exe       "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Dialog\ProjectFiles\Microsoft\Release\Dialog.exe                     "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy DialogBars\ProjectFiles\Microsoft\Release\DialogBars.exe             "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy DialogDemo\ProjectFiles\Microsoft\Release\DialogDemo.exe             "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy DialogTab\ProjectFiles\Microsoft\Release\DialogTab.exe               "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Dock\ProjectFiles\Microsoft\Release\Dock.exe                         "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy DockContainer\ProjectFiles\Microsoft\Release\DockContainer.exe       "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy DockTabbedMDI\ProjectFiles\Microsoft\Release\DockTabbedMDI.exe       "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
REM copy DX\ProjectFiles\Microsoft\Release\DX.exe                         "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Explorer\ProjectFiles\Microsoft\Release\Explorer.exe                 "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy FastGDI\ProjectFiles\Microsoft\Release\FastGDI.exe                   "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy FormDemo\ProjectFiles\Microsoft\Release\FormDemo.exe                 "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Frame\ProjectFiles\Microsoft\Release\Frame.exe                       "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy MDIFrame\ProjectFiles\Microsoft\Release\MDIFrame.exe                 "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy MDIFrameDemo\ProjectFiles\Microsoft\Release\MDIDemo.exe              "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy MDIFrameSplitter\ProjectFiles\Microsoft\Release\MDIFrameSplitter.exe "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Networking\ClientDlg\Microsoft\Release\Client.exe                    "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Networking\ServerDlg\Microsoft\Release\Server.exe                    "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy NotePad\ProjectFiles\Microsoft\Release\Notepad.exe                   "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Performance\ProjectFiles\Microsoft\Release\Performance.exe           "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Picture\ProjectFiles\Microsoft\Release\Picture.exe                   "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy PropertySheet\ProjectFiles\Microsoft\Release\PropertySheet.exe       "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Scribble\ProjectFiles\Microsoft\Release\Scribble.exe                 "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Simple\ProjectFiles\Microsoft\Release\Simple.exe                     "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Splitter\ProjectFiles\Microsoft\Release\Splitter.exe                 "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy TabDemo\ProjectFiles\Microsoft\Release\TabDemo.exe                   "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Themes\ProjectFiles\Microsoft\Release\Themes.exe                     "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Threads\ProjectFiles\Microsoft\Release\Threads.exe                   "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"
copy Tray\ProjectFiles\Microsoft\Release\Tray.exe                         "..\output\VS2003\Release"    >>"..\output\CodeBlocks.log"


REM: Copy the executables to the testing directories
mkdir "..\output\Borland"
mkdir "..\output\Borland\Debug"

ECHO "Copying Borland Debug files" >>"..\output\CodeBlocks.log"
copy Browser\ProjectFiles\Borland\Debug\Browser.exe                   "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy CustomControl\ProjectFiles\Borland\Debug\CustomControl.exe       "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Dialog\ProjectFiles\Borland\Debug\Dialog.exe                     "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy DialogBars\ProjectFiles\Borland\Debug\DialogBars.exe             "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy DialogDemo\ProjectFiles\Borland\Debug\DialogDemo.exe             "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy DialogTab\ProjectFiles\Borland\Debug\DialogTab.exe               "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Dock\ProjectFiles\Borland\Debug\Dock.exe                         "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy DockContainer\ProjectFiles\Borland\Debug\DockContainer.exe       "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy DockTabbedMDI\ProjectFiles\Borland\Debug\DockTabbedMDI.exe       "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
REM copy DX\ProjectFiles\Borland\Debug\DX.exe                         "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Explorer\ProjectFiles\Borland\Debug\Explorer.exe                 "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy FastGDI\ProjectFiles\Borland\Debug\FastGDI.exe                   "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy FormDemo\ProjectFiles\Borland\Debug\FormDemo.exe                 "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Frame\ProjectFiles\Borland\Debug\Frame.exe                       "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy MDIFrame\ProjectFiles\Borland\Debug\MDIFrame.exe                 "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy MDIFrameDemo\ProjectFiles\Borland\Debug\MDIDemo.exe              "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy MDIFrameSplitter\ProjectFiles\Borland\Debug\MDIFrameSplitter.exe "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Networking\ClientDlg\Borland\Debug\Client.exe                    "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Networking\ServerDlg\Borland\Debug\Server.exe                    "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy NotePad\ProjectFiles\Borland\Debug\Notepad.exe                   "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Performance\ProjectFiles\Borland\Debug\Performance.exe           "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Picture\ProjectFiles\Borland\Debug\Picture.exe                   "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy PropertySheet\ProjectFiles\Borland\Debug\PropertySheet.exe       "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Scribble\ProjectFiles\Borland\Debug\Scribble.exe                 "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Simple\ProjectFiles\Borland\Debug\Simple.exe                     "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Splitter\ProjectFiles\Borland\Debug\Splitter.exe                 "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy TabDemo\ProjectFiles\Borland\Debug\TabDemo.exe                   "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Themes\ProjectFiles\Borland\Debug\Themes.exe                     "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Threads\ProjectFiles\Borland\Debug\Threads.exe                   "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"
copy Tray\ProjectFiles\Borland\Debug\Tray.exe                         "..\output\Borland\Debug"    >>"..\output\CodeBlocks.log"

mkdir "..\output\Borland\Release"

ECHO "Copying Borland Release files" >>"..\output\CodeBlocks.log"
copy Browser\ProjectFiles\Borland\Release\Browser.exe                   "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy CustomControl\ProjectFiles\Borland\Release\CustomControl.exe       "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Dialog\ProjectFiles\Borland\Release\Dialog.exe                     "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy DialogBars\ProjectFiles\Borland\Release\DialogBars.exe             "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy DialogDemo\ProjectFiles\Borland\Release\DialogDemo.exe             "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy DialogTab\ProjectFiles\Borland\Release\DialogTab.exe               "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Dock\ProjectFiles\Borland\Release\Dock.exe                         "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy DockContainer\ProjectFiles\Borland\Release\DockContainer.exe       "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy DockTabbedMDI\ProjectFiles\Borland\Release\DockTabbedMDI.exe       "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
REM copy DX\ProjectFiles\Borland\Release\DX.exe                         "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Explorer\ProjectFiles\Borland\Release\Explorer.exe                 "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy FastGDI\ProjectFiles\Borland\Release\FastGDI.exe                   "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy FormDemo\ProjectFiles\Borland\Release\FormDemo.exe                 "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Frame\ProjectFiles\Borland\Release\Frame.exe                       "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy MDIFrame\ProjectFiles\Borland\Release\MDIFrame.exe                 "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy MDIFrameDemo\ProjectFiles\Borland\Release\MDIDemo.exe              "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy MDIFrameSplitter\ProjectFiles\Borland\Release\MDIFrameSplitter.exe "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Networking\ClientDlg\Borland\Release\Client.exe                    "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Networking\ServerDlg\Borland\Release\Server.exe                    "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy NotePad\ProjectFiles\Borland\Release\Notepad.exe                   "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Performance\ProjectFiles\Borland\Release\Performance.exe           "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Picture\ProjectFiles\Borland\Release\Picture.exe                   "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy PropertySheet\ProjectFiles\Borland\Release\PropertySheet.exe       "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Scribble\ProjectFiles\Borland\Release\Scribble.exe                 "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Simple\ProjectFiles\Borland\Release\Simple.exe                     "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Splitter\ProjectFiles\Borland\Release\Splitter.exe                 "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy TabDemo\ProjectFiles\Borland\Release\TabDemo.exe                   "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Themes\ProjectFiles\Borland\Release\Themes.exe                     "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Threads\ProjectFiles\Borland\Release\Threads.exe                   "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"
copy Tray\ProjectFiles\Borland\Release\Tray.exe                         "..\output\Borland\Release"    >>"..\output\CodeBlocks.log"


REM: Copy the executables to the testing directories
mkdir "..\output\MinGW"
mkdir "..\output\MinGW\Debug"

ECHO "Copying MinGW Debug files" >>"..\output\CodeBlocks.log"
copy Browser\ProjectFiles\GNU\Debug\Browser.exe                   "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy CustomControl\ProjectFiles\GNU\Debug\CustomControl.exe       "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Dialog\ProjectFiles\GNU\Debug\Dialog.exe                     "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy DialogBars\ProjectFiles\GNU\Debug\DialogBars.exe             "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy DialogDemo\ProjectFiles\GNU\Debug\DialogDemo.exe             "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy DialogTab\ProjectFiles\GNU\Debug\DialogTab.exe               "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Dock\ProjectFiles\GNU\Debug\Dock.exe                         "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy DockContainer\ProjectFiles\GNU\Debug\DockContainer.exe       "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy DockTabbedMDI\ProjectFiles\GNU\Debug\DockTabbedMDI.exe       "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
REM copy DX\ProjectFiles\GNU\Debug\DX.exe                         "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Explorer\ProjectFiles\GNU\Debug\Explorer.exe                 "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy FastGDI\ProjectFiles\GNU\Debug\FastGDI.exe                   "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy FormDemo\ProjectFiles\GNU\Debug\FormDemo.exe                 "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Frame\ProjectFiles\GNU\Debug\Frame.exe                       "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy MDIFrame\ProjectFiles\GNU\Debug\MDIFrame.exe                 "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy MDIFrameDemo\ProjectFiles\GNU\Debug\MDIDemo.exe              "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy MDIFrameSplitter\ProjectFiles\GNU\Debug\MDIFrameSplitter.exe "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Networking\ClientDlg\GNU\Debug\Client.exe                    "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Networking\ServerDlg\GNU\Debug\Server.exe                    "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy NotePad\ProjectFiles\GNU\Debug\Notepad.exe                   "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Performance\ProjectFiles\GNU\Debug\Performance.exe           "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Picture\ProjectFiles\GNU\Debug\Picture.exe                   "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy PropertySheet\ProjectFiles\GNU\Debug\PropertySheet.exe       "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Scribble\ProjectFiles\GNU\Debug\Scribble.exe                 "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Simple\ProjectFiles\GNU\Debug\Simple.exe                     "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Splitter\ProjectFiles\GNU\Debug\Splitter.exe                 "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy TabDemo\ProjectFiles\GNU\Debug\TabDemo.exe                   "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Themes\ProjectFiles\GNU\Debug\Themes.exe                     "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Threads\ProjectFiles\GNU\Debug\Threads.exe                   "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"
copy Tray\ProjectFiles\GNU\Debug\Tray.exe                         "..\output\MinGW\Debug"    >>"..\output\CodeBlocks.log"

mkdir "..\output\MinGW\Release"

ECHO "Copying MinGW Release files" >>"..\output\CodeBlocks.log"
copy Browser\ProjectFiles\GNU\Release\Browser.exe                   "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy CustomControl\ProjectFiles\GNU\Release\CustomControl.exe       "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Dialog\ProjectFiles\GNU\Release\Dialog.exe                     "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy DialogBars\ProjectFiles\GNU\Release\DialogBars.exe             "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy DialogDemo\ProjectFiles\GNU\Release\DialogDemo.exe             "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy DialogTab\ProjectFiles\GNU\Release\DialogTab.exe               "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Dock\ProjectFiles\GNU\Release\Dock.exe                         "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy DockContainer\ProjectFiles\GNU\Release\DockContainer.exe       "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy DockTabbedMDI\ProjectFiles\GNU\Release\DockTabbedMDI.exe       "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
REM copy DX\ProjectFiles\GNU\Release\DX.exe                         "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Explorer\ProjectFiles\GNU\Release\Explorer.exe                 "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy FastGDI\ProjectFiles\GNU\Release\FastGDI.exe                   "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy FormDemo\ProjectFiles\GNU\Release\FormDemo.exe                 "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Frame\ProjectFiles\GNU\Release\Frame.exe                       "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy MDIFrame\ProjectFiles\GNU\Release\MDIFrame.exe                 "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy MDIFrameDemo\ProjectFiles\GNU\Release\MDIDemo.exe              "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy MDIFrameSplitter\ProjectFiles\GNU\Release\MDIFrameSplitter.exe "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Networking\ClientDlg\GNU\Release\Client.exe                    "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Networking\ServerDlg\GNU\Release\Server.exe                    "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy NotePad\ProjectFiles\GNU\Release\Notepad.exe                   "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Performance\ProjectFiles\GNU\Release\Performance.exe           "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Picture\ProjectFiles\GNU\Release\Picture.exe                   "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy PropertySheet\ProjectFiles\GNU\Release\PropertySheet.exe       "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Scribble\ProjectFiles\GNU\Release\Scribble.exe                 "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Simple\ProjectFiles\GNU\Release\Simple.exe                     "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Splitter\ProjectFiles\GNU\Release\Splitter.exe                 "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy TabDemo\ProjectFiles\GNU\Release\TabDemo.exe                   "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Themes\ProjectFiles\GNU\Release\Themes.exe                     "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Threads\ProjectFiles\GNU\Release\Threads.exe                   "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"
copy Tray\ProjectFiles\GNU\Debug\Tray.exe                           "..\output\MinGW\Release"    >>"..\output\CodeBlocks.log"


REM: Pop the directory change off the stack
popd

